%%%%%%%%%% Modulator: simulation parameters %%%%%

fs=35.2e6; % Sampling frequency
Ts=1/fs; % Sampling time
fi=137.5e3; % Input frequency
OSR=64; % OverSampling Ratio
N=65536; % Number of Points

%%%%%%%%%% DEM Parameters and Capacitor Feedback Arrays %%%%%%%%%%%

nlevels=16; % Number of quantization levels
Cs1=10e-12; % Sampling Capacitor
sigma=[1/100]; % Capacitor mismatch standard deviation

%% Capacitor array 

n_elements_1=(nlevels-1); % Binary array
n_elements_2=floor((nlevels)/2); % Tri-level array 
Cs1_array_1=Cs1/n_elements_1*(ones(1,n_elements_1)); % No mismatch - binary
Cs1_array_2=Cs1/n_elements_1*(ones(1,n_elements_1)+sigma*randn(1,n_elements_1)); % With mismatch - binary
Cs1_array_3=Cs1/n_elements_2*(ones(1,n_elements_2)+sigma*randn(1,n_elements_2)); % With mismatch - tri_level
Cs1_array_4=Cs1/n_elements_2*(ones(1,n_elements_2)); % No mismatch - tri_level           

