%% NTF vs. f for different noise-shaping orders
clear; clc; clf;

fr=-0.5:1e-2:+0.5;
O=2*pi*fr;
L=0:5;
for 	i=1:length(fr)
	for 	j=1:length(L)
    		NTF(i,j)=abs((2*sin(O(i)/2)).^L(j));
            NTF2(i,j)=NTF(i,j)*NTF(i,j);
	end
end

plot(fr,NTF2);
hold on; grid on;

axis([-0.5 0.5 0 16])
xlabel('Normalized frequency, f / f_s');
ylabel('|NTF(f)|^2');

text(0.44,1.6,'L=0');
text(0.44,4.6,'L=1');
text(0.36,9.4,'L=2');
text(0.29,12.4,'L=3');
text(0.26,14.8,'L=4');
text(0.17,14.8,'L=5');

shg;