%% NTF vs. f for different noise-shaping orders
clear; clc; clf;

N=1;
OSRpower=0:7;
OSR=2.^OSRpower;
L=0:5;

for 	i=1:length(OSRpower)
	for 	j=1:length(L)
		DR(i,j)=3/2*(2^N-1)^2*(2*L(j)+1)*OSR(i)^(2*L(j)+1)/pi^(2*L(j));
		DRdB(i,j)=10*log10(DR(i,j));
		ENOB(i,j)=(DRdB(i,j)-1.76)/6.02;
	end
end

shg;
%plotyy(OSRpower,DRdB,OSRpower,ENOB)
plot(OSRpower,DRdB)

grid on; hold on; zoom on;
axis([0 7 0 120])
xlabel('Oversampling ratio, OSR');
ylabel('Dynamic range, DR (dB)');

text(6.5,17,'L=0');
text(6.5,51,'L=1');
text(6.5,82,'L=2');
text(6.5,112,'L=3');
text(5.4,112,'L=4');
text(4.0,112,'L=5');