% Example of optimizing the NTF zeros to minimize NTF using Schreier'
% toolbox
clear all;
close all;
% Setup parameters
fs =1;
M = 64;   % OSR = M
Hinf=1.5;
L=4; % Filter order
% Synthesize NTF with optimized placement of zeroes
NTF = synthesizeNTF(L,M,1,Hinf);
[numNTF,denNTF] = tfdata(NTF);
figure(1);
% Plot ideal NTF 
f = [linspace(0,1/M,100) linspace(1/M,1,500)];
s = j*2*pi*f;
z = exp(s);

figure(1); clf;
plot(f,dbv(evalTF(NTF,z)),'b','Linewidth',2);
axis([0 0.5 -120 40]);
hold on;
grid on;
%title('Desired NTF');

% Synthesize NTF with zeroes at DC
NTFdc = synthesizeNTF(L,M,0,Hinf);
[numNTFdc,denNTFdc] = tfdata(NTFdc);
plot(f,dbv(evalTF(NTFdc,z)),'r','Linewidth',2);
NTFideal=(abs(z-1)).^L;
plot(f,20*log10(NTFideal),'k','Linewidth',2);

figure(2);
pzplot(NTF);
hold
pzplot(NTFdc,'r');