clear; clc; clf;
%% SDM general parameters
FS=1; Vref=FS/2;
fs=1e6; N=65536*4;
Ain=0.5*Vref;
fin=fs/123;

%% OPTIMIZATION OF fin FOR MINIMUM SIDELOBES IN FFT
Np=floor(N*fin/fs); % Number of periods of Vin in the simulated time (N/fs)
fin=Np*fs/N; % fin is re-adjusted from an integer Np

%% QUANTIZER PARAMETERS
ts=1/fs;
Vq=Vref;

sim('SL2_LPSDM_ideal.mdl');
[pxx,f,pxx_bin,fbin]=spect(y,fs);

plot(f/fs,10*log10(pxx)); hold on; grid on;
xlabel('Normalized frequency, f / f_s'); ylabel('PSD (dB)');
axis([0 0.5 -220 0]);
shg;