function [pxx,f,pxx_bin,fbin]=spect(tim,fstep);

%% function [pxx,f,pxx_bin,fbin]=spect(tim,fstep);
%% Calculates and plots the PSD of tim from 0 to fstep/2 in dB/Hz (integral) and
%% the PSD x BIN in dB (summ) in a one-sided representation
%
%% Total power is sum(pxx)*fbin (integral) and sum(pxx_bin) (summ)

N=length(tim);
W=hanning(N);
%W=blackman(N);
%W=kaiser(N,20);
xw=W.*tim;
px=abs(fft(xw/sqrt(N))).^2;
px=px/norm(W)^2;
pxx_bin=2*px(1:ceil(N/2));	% Factor 2 for the single-side representation

%figure;
%subplot(2,1,1),plot(1:ceil(N/2),10*log10(pxx_bin)); grid on;
%xlabel('BIN'); ylabel('PSD x BIN (dB)');
%axis([1 ceil(N/2) -200 0.9*max(10*log10(pxx_bin))]);

fbin=fstep/N;
f=(fbin:fbin:fstep)'; f=f(1:ceil(N/2));
pxx=2*px(1:ceil(N/2))/fbin;	% Factor 2 for the single-side representation
%subplot(2,1,2),plot(f,10*log10(pxx)); grid on;
%xlabel('Frequency (Hz)'); ylabel('PSD (dB/Hz)');
%axis([f(1) f(ceil(N/2)) -250 0.9*max(10*log10(pxx))]);
