%% IBN due to linear incomplete settling in cascade SDMs
clear; clc;

OSR=[16 32 64];
GBnorm=0.1:0.2:3.1; % Normalized GB during integration --> GBi/fs with GBi in Hz

e_ge=exp(-pi*GBnorm); % Linear error due to integration --> exp(-2*pi*GBi(Hz)*Ts/2)
syms z

for j=1:length(OSR);
    for i=1:length(GBnorm);
        est=e_ge(i);
        %g1=0.25; g1p=0.25; g2=1; g2p=0.5; g3=1; g3p=0.5; g3pp=0.5; g4=1; g4p=0.5; g4pp=0.5;
        d0=1; d1=2; d2=0; d3=2;

        IBN1_st_211_approx=1/12*pi^4/(5*OSR(j)^5)*(abs(est)+abs(est))^2; 
        IBN2_st_211_approx=1/12*d1^2*pi^6/(7*OSR(j)^7)*(abs(est))^2;
        IBN3_st_211_approx=1/12*d3^2*pi^8/(9*OSR(j)^9)*(1+abs(est))^2;
        IBN_st_211_approx(i,j)=IBN1_st_211_approx+IBN2_st_211_approx+IBN3_st_211_approx;
    end
end

clf; shg;

%% SIMSIDES RESULTS OBTAINED FROM MASH211_mdl.params & MASH211_settling.mdl
IBN=[
  -16.7571   -9.5686  -33.5581
  -56.1183  -75.8312  -87.7631
  -66.3468  -82.6152  -96.5972
  -70.8653  -88.1146 -101.2849
  -75.0040  -92.5271 -106.9251
  -78.8357  -97.5093 -112.4563
  -80.8815 -102.0157 -118.4989
  -82.1739 -105.5941 -123.0733
  -82.9227 -108.0884 -128.0251
  -82.7417 -108.9513 -132.2996
  -82.7638 -110.0598 -135.0550
  -82.7137 -110.0676 -135.3629
  -83.0956 -110.2458 -136.0349
  -82.7949 -109.9880 -136.4897
  -82.7077 -110.4886 -135.3930
  -83.1041 -109.8439 -136.2102
 ];

plot(GBnorm,IBN(:,1),'*b-','MarkerSize',8); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_211_approx(:,1)),'rs--','MarkerSize',6);
plot(GBnorm,IBN(:,2),'*b-','MarkerSize',8); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_211_approx(:,2)),'rs--','MarkerSize',6);
plot(GBnorm,IBN(:,3),'*b-','MarkerSize',8); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_211_approx(:,3)),'rs--','MarkerSize',6);
axis([0 3 -140 -50]);
xlabel('Normalized GB, GB/f_s'); ylabel('IBN (dB)');
legend('Behavioral model','Approx. equation','Location','NorthEast');
x_txt=2.4;
text(x_txt,-77,'OSR = 16');
text(x_txt,-105,'OSR = 32');
text(x_txt,-132,'OSR = 64');