clear;
clf; shg;

fs=80e6; N=65536;
data=load('spect_SL3_SR_GB1.txt');
f=data(:,1);
pxx_SR3d0=data(:,2);
pxx_SR3d5=data(:,3);
pxx_SR4d0=data(:,4);

fnorm=f/fs;
semilogx(fnorm,10*log10(pxx_SR3d0),'k')
grid on; hold on;
semilogx(fnorm,10*log10(pxx_SR3d5),'b')
semilogx(fnorm,10*log10(pxx_SR4d0),'r')
axis([1/N 1 -220 -40])
xlabel('Normalized frequency, f/f_s');
ylabel('PSD (dB)')
legend('SR=3.0V_{ref}f_s','SR=3.5V_{ref}f_s','SR=4.0V_{ref}f_s','Location','NorthWest');

bin_fin=342/2;
semilogx(fnorm(bin_fin),10*log10(pxx_SR3d0(bin_fin)),'ks-','MarkerFaceColor','k','MarkerSize',6)
semilogx(fnorm(bin_fin),10*log10(pxx_SR3d5(bin_fin)),'bs-','MarkerFaceColor','b','MarkerSize',6)
semilogx(fnorm(bin_fin),10*log10(pxx_SR4d0(bin_fin)),'rs-','MarkerFaceColor','r','MarkerSize',6)

bin_3fin=3*bin_fin-2;
semilogx(fnorm(bin_3fin),10*log10(pxx_SR3d0(bin_3fin)),'ks-','MarkerFaceColor','k','MarkerSize',6)
semilogx(fnorm(bin_3fin),10*log10(pxx_SR3d5(bin_3fin)),'bs-','MarkerFaceColor','b','MarkerSize',6)
semilogx(fnorm(bin_3fin),10*log10(pxx_SR4d0(bin_3fin)),'rs-','MarkerFaceColor','r','MarkerSize',6)