clear; clc; clf;

file='Settling_Ron_1_500_1kohm.txt';

tmp=load(file);
t=tmp(1:1503/3,1)-25.01e-9;
n=size(tmp,1);

Vo1=tmp(1:1/3*n,2);
Vo2=tmp(1/3*n+1:2/3*n,2);
Vo3=tmp(2/3*n+1:n,2);

tick1=ceil(1/10*1/3*n);
Vo11=Vo1(tick1);
Vo21=Vo2(tick1-10);
Vo31=Vo3(tick1-20);
tick2=ceil(6/10*1/3*n);
Vo12=Vo1(tick2);
Vo22=Vo2(tick2-10);
Vo32=Vo3(tick2-20);

plot(t(tick1)*1e9,Vo11,'-sk'); hold on; grid on;
plot(t(tick1-10)*1e9,Vo21,'-*b'); hold on; grid on;
plot(t(tick1-20)*1e9,Vo31,'-vr'); hold on; grid on;

plot(t(tick2)*1e9,Vo12,'-sk'); hold on; grid on;
plot(t(tick2-10)*1e9,Vo22,'-*b'); hold on; grid on;
plot(t(tick2-20)*1e9,Vo32,'-vr'); hold on; grid on;

plot(t*1e9,Vo1,'-k'); hold on; grid on;
plot(t*1e9,Vo2,'-b'); hold on; grid on;
plot(t*1e9,Vo3,'-r'); hold on; grid on;

xlabel('Time (ns)'); ylabel('Output voltage, Vo (V)');
axis([0 50 -0.15 +0.3]);

legend('Ron=0\Omega','Ron=500\Omega','Ron=1k\Omega','Location','SouthEast');

xpos=12;
ypos=-0';
fsize=20;
text(xpos+25*0,ypos,'\Phi_2','FontSize',fsize);
text(xpos+25*1,ypos,'\Phi_1','FontSize',fsize);