%% IBN due to linear incomplete settling in cascade SDMs
clear; clc;

OSR=[16 32];
GBnorm=0.3:0.2:3.1; % Normalized GB during integration --> GBi/fs with GBi in Hz
fRon=[2.5 5 10 1e3]; % Normalized fRon to fs

for j=1:length(OSR);
    for k=1:length(fRon);
        for i=1:length(GBnorm);
            
            est=exp(-pi*GBnorm(i)/(1+GBnorm(i)/fRon(k)));
            d0=1; d1=2; d2=0; d3=2;
            
            IBN1_st_211_approx=1/12*pi^4/(5*OSR(j)^5)*(abs(est)+abs(est))^2;
            IBN2_st_211_approx=1/12*d1^2*pi^6/(7*OSR(j)^7)*(abs(est))^2;
            IBN3_st_211_approx=1/12*d3^2*pi^8/(9*OSR(j)^9)*(1+abs(est))^2;
            IBN_st_211_approx(k,i,j)=IBN1_st_211_approx+IBN2_st_211_approx+IBN3_st_211_approx;
        end
    end
end

clf; shg;

plot(GBnorm,10*log10(IBN_st_211_approx(4,:,1)),'ks-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_211_approx(3,:,1)),'b*-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_211_approx(2,:,1)),'md-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_211_approx(1,:,1)),'r^-','MarkerSize',6); hold on; grid on;

plot(GBnorm,10*log10(IBN_st_211_approx(4,:,2)),'ks-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_211_approx(3,:,2)),'b*-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_211_approx(2,:,2)),'md-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_211_approx(1,:,2)),'r^-','MarkerSize',6); hold on; grid on;

axis([0 3 -120 -40]);
xlabel('Normalized GB, GB/f_s'); ylabel('IBN (dB)');
legend('f_{Ron}=inf','f_{Ron}=10f_s','f_{Ron}=5f_s','f_{Ron}=2.5f_s','Location','NorthEast');
x_txt=2.4;
text(x_txt,-86,'OSR = 16');
text(x_txt,-113,'OSR = 32');