%% IBN due to linear incomplete settling in single-loop SDMs
clear;

OSR=[32 64];
GBnorm=0.3:0.2:3.1; % Normalized GB during integration --> GBi/fs with GBi in Hz
fRon=[2.5 5 10 1e3]; % Normalized fRon to fs

for j=1:length(OSR);
    for k=1:length(fRon);
        for i=1:length(GBnorm);
            
            est=exp(-pi*GBnorm(i)/(1+GBnorm(i)/fRon(k)));
            
            a1=0.2; a2=0.5; a3=0.5; kq=2/a3;
            IBN_st_SL3_approx(k,i,j)=1/12*1/(kq*a1*a2*a3)^2*(1+est)^2*(1+est)^2*(1+est)^2*pi^6/(7*OSR(j)^7);
        end
    end
end

clf; shg;

plot(GBnorm,10*log10(IBN_st_SL3_approx(4,:,1)),'ks-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_SL3_approx(3,:,1)),'b*-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_SL3_approx(2,:,1)),'md-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_SL3_approx(1,:,1)),'r^-','MarkerSize',6); hold on; grid on;

plot(GBnorm,10*log10(IBN_st_SL3_approx(4,:,2)),'ks-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_SL3_approx(3,:,2)),'b*-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_SL3_approx(2,:,2)),'md-','MarkerSize',6); hold on; grid on;
plot(GBnorm,10*log10(IBN_st_SL3_approx(1,:,2)),'r^-','MarkerSize',6); hold on; grid on;

axis([0 3 -105 -70]);
xlabel('Normalized GB, GB/f_s'); ylabel('IBN (dB)');
legend('f_{Ron}=inf','f_{Ron}=10f_s','f_{Ron}=5f_s','f_{Ron}=2.5f_s','Location','NorthEast');
x_txt=2.4;
text(x_txt,-78,'OSR = 32');
text(x_txt,-99,'OSR = 64');