%% INTEGRATOR LEACKAGE CONSIDERED IN A 2nd-ORDER SDM
clear; clf; clc;
syms z X Eq H u
syms g1 g1p g2 g2p
L=2;
[I1s,I2s,Ys]=solve('I1=g1*H*X-g1p*H*Y','I2=g2*H*I1-g2p*H*Y','Y=I2/(g1p*g2)+Eq','I1','I2','Y');
Ys=subs(Ys); Ys=simple(Ys);
H=1/(1+2*u)*z/(1-z*(1+u)/(1+2*u)); % z means z^(-1) for easing the formulae reading
% This non-approximated H(z) (only g~1 is assumend) provides better results for low Av
g1p=g1;
g2p=2*g1p*g2;

Ys=subs(Ys); Ys=simple(Ys);
STF=simple(subs(Ys,Eq,0)/X)
NTF=simple(subs(Ys,X,0)/Eq)

% Check of results
Av_dB=[20 30 40 50 1000000];
Av=10.^(Av_dB/20);
u=1./Av;

fs=1; n=5e4;
f=fs/n:fs/n:+fs/2;
z=exp(-1i*2*pi*f/fs);

for i=1:length(Av)
    u=1/Av(i);
    NTFev=eval(NTF);
    Sq=1/(12*fs)*abs(NTFev).^2;
    semilogx(f,10*log10(Sq));
    if i==1
       hold on; grid on;
    end
end
xlabel('Normalized frequency, f / f_s');
ylabel('Noise PSD (dB)');
axis([0.5e-4 1 -140 5]);
text(1.1e-4,-47, 'A_v= 20dB');
text(1.1e-4,-66, 'A_v= 30dB');
text(1.1e-4,-85, 'A_v= 40dB');
text(1.1e-4,-102,'A_v= 50dB');
text(2.2e-4,-130,'Ideal');