%% IBN due to finite DC gain of amplifiers
clear;

OSR=[16 32];
Av_dB=0:5:100;

Av=10.^(Av_dB/20);
syms z

for j=1:length(OSR);
    for i=1:length(Av);
        d0=1; d1=2; d2=0; d3=2;
        IBN_Av_211_approx(i,j)=1/12*4*pi^2/(3*Av(i)^2*OSR(j)^3)...
                               +1/12*d1^2*pi^4/(5*Av(i)^2*OSR(j)^5)...
                               +1/(2^1-1)^2/12*d3^2*(pi^6/(7*Av(i)^2*OSR(j)^7)+pi^8/(9*OSR(j)^9));
        IBN_Av_4_approx(i,j)=1/12*(1/(Av(i)^8*OSR(j))+4*pi^2/(Av(i)^6*3*OSR(j)^3)+6*pi^4/(Av(i)^4*5*OSR(j)^5)+4*pi^6/(Av(i)^2*7*OSR(j)^7)+pi^8/(9*OSR(j)^9));
        % Non-approximated NTFs
        u=1/Av(i);
        NTF1_Av_211=2*z^2 - 2*z^3 + z^4 + (2*z*(z^4 - z^3 + z))/(u*(z - 2) - 1) + (z^3*(z^3 - 2*z + 2))/(u*(z - 2) - 1)^2 + (z^4*(z - 1)^2)/(u*(z - 2) - 1)^3; % From TF_Av_211.m - z means z^(-1)
        NTF2_Av_211=-(2*u*z*(z - 1)^2*(z - 2))/(2*u - u*z + 1);
        NTF3_Av_211=-(2*(z - 1)^3*(2*u - z - u*z + 1))/(2*u - u*z + 1);
        IBN1_Av_211=num_eval_IBN(NTF1_Av_211,1,OSR(j),1e3);
        IBN2_Av_211=num_eval_IBN(NTF2_Av_211,1,OSR(j),1e3);
        IBN3_Av_211=num_eval_IBN(NTF3_Av_211,1,OSR(j),1e3);
        IBN_Av_211(i,j)=IBN1_Av_211+IBN2_Av_211+IBN3_Av_211;
        NTF_Av_4=(z - 2*u + u*z - 1)^4/(2*u - u*z + 1)^4;
        IBN_Av_4(i,j)=num_eval_IBN(NTF_Av_4,1,OSR(j),1e3);
    end
end

plot(20*log10(Av),10*log10(IBN_Av_211(:,1)),'sk-','MarkerSize',8); hold on; grid on;
plot(20*log10(Av),10*log10(IBN_Av_211(:,2)),'+k-','MarkerSize',8);

plot(20*log10(Av),10*log10(IBN_Av_4(:,1)),'ob-','MarkerSize',8);
plot(20*log10(Av),10*log10(IBN_Av_4(:,2)),'xb-','MarkerSize',8);

plot(20*log10(Av),10*log10(IBN_Av_211_approx(:,1)),'k--','MarkerSize',8);
plot(20*log10(Av),10*log10(IBN_Av_211_approx(:,2)),'k--','MarkerSize',8);

plot(20*log10(Av),10*log10(IBN_Av_4_approx(:,1)),'b--','MarkerSize',8);
plot(20*log10(Av),10*log10(IBN_Av_4_approx(:,2)),'b--','MarkerSize',8);

legend('211, OSR=16','211, OSR=32','4th order, OSR=16','4th order, OSR=32','Approx. equation','Location','NorthEast');
axis([0 max(Av_dB) -125 -50]);
xlabel('A_v (dB)'); ylabel('IBN (dB)'); grid on;