%% IBN due to finite DC gain of amplifiers in single-loop SDMs
clear;

OSR=[16 32];
Av_dB=0:5:100;

Av=10.^(Av_dB/20);
syms z

for j=1:length(OSR);
    for i=1:length(Av);
        IBN_Av_2_approx(i,j)=1/12*(1/(Av(i)^4*OSR(j))+2*pi^2/(Av(i)^2*3*OSR(j)^3)+pi^4/(5*OSR(j)^5));
        IBN_Av_3_approx(i,j)=1/12*(1/(Av(i)^6*OSR(j))+3*pi^2/(Av(i)^4*3*OSR(j)^3)+3*pi^4/(Av(i)^2*5*OSR(j)^5)+pi^6/(7*OSR(j)^7));
        %IBN_Av_4_approx(i,j)=1/12*(1/(Av(i)^8*OSR(j))+4*pi^2/(Av(i)^6*3*OSR(j)^3)+6*pi^4/(Av(i)^4*5*OSR(j)^5)+4*pi^6/(Av(i)^2*7*OSR(j)^7)+pi^8/(9*OSR(j)^9));
        % Non-approximated NTF
        u=1/Av(i);
        NTF_Av_2=(2*u - z - u*z + 1)^2/(2*u - u*z + 1)^2; % From TF_Av_2.m - z means z^(-1)
        NTF_Av_3=(2*u - z - u*z + 1)^3/(2*u - u*z + 1)^3; % From TF_Av_3.m - z means z^(-1)
        %NTF_Av_4=(z - 2*u + u*z - 1)^4/(2*u - u*z + 1)^4;
        IBN_Av_2(i,j)=num_eval_IBN(NTF_Av_2,1,OSR(j),1e3);
        IBN_Av_3(i,j)=num_eval_IBN(NTF_Av_3,1,OSR(j),1e3);
        %IBN_Av_4(i,j)=num_eval_IBN(NTF_Av_4,1,OSR(j),1e3);
    end
end

plot(20*log10(Av),10*log10(IBN_Av_2(:,1)),'sk-','MarkerSize',8); hold on; grid on;
plot(20*log10(Av),10*log10(IBN_Av_2(:,2)),'+k-','MarkerSize',8);

plot(20*log10(Av),10*log10(IBN_Av_3(:,1)),'ob-','MarkerSize',8);
plot(20*log10(Av),10*log10(IBN_Av_3(:,2)),'xb-','MarkerSize',8);

plot(20*log10(Av),10*log10(IBN_Av_2_approx(:,1)),'k--','MarkerSize',8);
plot(20*log10(Av),10*log10(IBN_Av_2_approx(:,2)),'k--','MarkerSize',8);

plot(20*log10(Av),10*log10(IBN_Av_3_approx(:,1)),'b--','MarkerSize',8);
plot(20*log10(Av),10*log10(IBN_Av_3_approx(:,2)),'b--','MarkerSize',8);

legend('2nd order, OSR=16','2nd order, OSR=32','3rd order, OSR=16','3rd order, OSR=32','Approx. equation','Location','SouthWest');
axis([0 max(Av_dB) -125 -50]);
xlabel('A_v (dB)'); ylabel('IBN (dB)'); grid on;