%% IBN due to capacitor mismatch in cascade SDMs
clear; clc;

OSR=32; %[16 32];
sigma_cap=logspace(-2,1,20); % Capacitor mismatch in %

e_me=3*sigma_cap/100; % Errors in the integrator weights are considered as 3*sigma_cap
syms z

for j=1:length(OSR);
        eg=e_me;
        d1=2; d3=2;
        
        eint1=eg; eint2=0; eint3=0; eint4=0;       
        IBN1_me_211_approx=1/12*pi^4/(5*OSR(j)^5)*(eint1+eint2).^2; 
        IBN2_me_211_approx=1/12*d1^2*pi^6/(7*OSR(j)^7)*(eint3).^2;
        IBN3_me_211_approx=1/12*d3^2*pi^8/(9*OSR(j)^9)*(1+eint4).^2;
        IBN_me_211_integ1(:,j)=IBN1_me_211_approx+IBN2_me_211_approx+IBN3_me_211_approx;
                
        eint1=0; eint2=eg; eint3=0; eint4=0;       
        IBN1_me_211_approx=1/12*pi^4/(5*OSR(j)^5)*(eint1+eint2).^2; 
        IBN2_me_211_approx=1/12*d1^2*pi^6/(7*OSR(j)^7)*(eint3).^2;
        IBN3_me_211_approx=1/12*d3^2*pi^8/(9*OSR(j)^9)*(1+eint4).^2;
        IBN_me_211_integ2(:,j)=IBN1_me_211_approx+IBN2_me_211_approx+IBN3_me_211_approx;
                
        eint1=0; eint2=0; eint3=eg; eint4=0;       
        IBN1_me_211_approx=1/12*pi^4/(5*OSR(j)^5)*(eint1+eint2).^2; 
        IBN2_me_211_approx=1/12*d1^2*pi^6/(7*OSR(j)^7)*(eint3).^2;
        IBN3_me_211_approx=1/12*d3^2*pi^8/(9*OSR(j)^9)*(1+eint4).^2;
        IBN_me_211_integ3(:,j)=IBN1_me_211_approx+IBN2_me_211_approx+IBN3_me_211_approx;
                
        eint1=0; eint2=0; eint3=0; eint4=eg;       
        IBN1_me_211_approx=1/12*pi^4/(5*OSR(j)^5)*(eint1+eint2).^2; 
        IBN2_me_211_approx=1/12*d1^2*pi^6/(7*OSR(j)^7)*(eint3).^2;
        IBN3_me_211_approx=1/12*d3^2*pi^8/(9*OSR(j)^9)*(1+eint4).^2;
        IBN_me_211_integ4(:,j)=IBN1_me_211_approx+IBN2_me_211_approx+IBN3_me_211_approx;
end

clf;
semilogx(sigma_cap,10*log10(IBN_me_211_integ1),'sr-','MarkerSize',8); hold on; grid on;
semilogx(sigma_cap,10*log10(IBN_me_211_integ2),'+b-','MarkerSize',8);
semilogx(sigma_cap,10*log10(IBN_me_211_integ3),'ok-','MarkerSize',8);
semilogx(sigma_cap,10*log10(IBN_me_211_integ4),'xm-','MarkerSize',8);

xlabel('Capacitor mismatch (%)'); ylabel('IBN (dB)');
legend('1st integrator','2nd integrator','3rd integrator','4th integrator','Location','NorthWest');

axis([min(sigma_cap) max(sigma_cap) -115 -80]);

% x_txt=0.0115;
% text(x_txt,-68,'OSR = 12');
% text(x_txt,-79,'OSR = 16');
% text(x_txt,-95,'OSR = 24');
% text(x_txt,-106,'OSR = 32');
% text(x_txt,-122,'OSR = 48');
% text(x_txt,-133,'OSR = 64');