%% OPTIMAL 3rd-ORDER SINGLE-BIT SIGMA-DELTA MODULATOR
% Marques, TCAS II Sept98
clear
syms z X Eq H
syms a1 a2 a3 kq
[I1s,I2s,I3s,Ys]=solve('I1=a1*H*(X-Y)','I2=a2*H*(I1-Y)','I3=a3*H*(I2-Y)','Y=kq*I3+Eq','I1','I2','I3','Y');
Ys=subs(Ys); Ys=simple(Ys);
a1=0.2; a2=0.5; a3=0.5;
kq=2/a3;
H=z/(1-z); % z means z^(-1) for easing the formulae reading

Ys=subs(Ys); Ys=simple(Ys);
STF=simple(subs(Ys,Eq,0)/X)
NTF=simple(subs(Ys,X,0)/Eq)

% Check of results
OSR=64; fs=1; n=1e3;
IBN_num_dB=10*log10(num_eval_IBN(NTF,fs,OSR,n)) % Numerical integration of non-approximated NTF
IBN_id_dB=10*log10(1/12*1/(kq*a1*a2*a3)^2*pi^6/(7*OSR^7)) % Closed-form expression SDM
IBN_id_dB=10*log10(1/12*pi^6/(7*OSR^7)) % Ideal SDM