function y=gen_white_noise_RRF(noise_Vrms,BW_noise,fs,N);
%% GENERATION OF NOISE SEQUENCE OF GIVEN Vrms AMPLITUDE IN A GIVEN BANDWIDTH
% Roco del Ro - Created: 05/11/08 - Last modified: 05/11/08
%
% noise_Vrms:   Intended amplitude (in Vrms) of the noise integrated in the BW_noise bandwidth
% BW_noise:     Bandwidth in which the noise has been integrated to extract its amplitude
% N:            Numer of samples of the noise time sequence
% fs:           Sampling frequency of the noise time sequence
% Roco del Ro - Created: 05/11/08 - Last modified: 05/11/08
%% GENERATION OF NOISE SEQUENCE
noise_psd=noise_Vrms^2;
x=sqrt(12*fs/(2*BW_noise)*noise_psd);
y=-x/2+x*rand(N,1);
y=y';
%% FFT ROUTINES USED IN IMSE
[pxx,f,pxx_bin,fbin]=spect(y',fs);
%figure;
%semilogx(f,10*log10(pxx_bin),'b'); grid on; hold on;
%xlabel('Frequency (Hz)'); ylabel('PSD x bin (dB)');
pow_y=sum(pxx_bin(1:N/2));
y_Vrms=sqrt(pow_y);
noise_Vrms_all_freqs=noise_Vrms*sqrt(fs/2/BW_noise);

bin_band_start=1;
bin_band_stop=max(find(f<BW_noise));
bin_band=bin_band_start:bin_band_stop;
pow_y_band_limited=sum(pxx_bin(bin_band));

noise_Vrms_audio=noise_Vrms*sqrt(20e3/BW_noise);

fprintf('\n Intended power of the noise time sequence at %.1fMHz = %.2f uVrms', 1e-6*fs, 1e6*noise_Vrms_all_freqs)
fprintf('\n ------------------------------------------------------------------')
fprintf('\n Standard deviation of generated noise sequence      = %.2f uVrms', 1e6*std(y))
fprintf('\n Noise calculation from FFT routines (0-fs/2)        = %.2f uVrms', 1e6*sqrt(pow_y))
fprintf('\n')
fprintf('\n Intended power of the noise in the %.1f-MHz band     = %.2f uVrms', 1e-6*BW_noise, 1e6*noise_Vrms)
fprintf('\n ------------------------------------------------------------------')
fprintf('\n Noise calculation from FFT routines (%.1f-MHz band)  = %.2f uVrms', 1e-6*BW_noise, 1e6*sqrt(pow_y_band_limited))
fprintf('\n')
fprintf('\n INTENDED NOISE POWER IN THE 20-kHz BAND --> %.2f uVrms', 1e6*noise_Vrms_audio)
fprintf('\n *******************************************************')
fprintf('\n')