function IBN=num_eval_IBN(NTF,fs,OSR,n);
%% NUMERICAL INTEGRATION OF IBN
% IBN_dB:   In-band noise (dB)
% NTF:      Noise transfer function
% fs:       Sampling frequency
% OSR:      Oversampling ratio
% n:        Length of the frequency vector

fb=fs/(2*OSR);
fbin=2*fb/n;
f=-fb:fbin:+fb;
z=exp(-1i*2*pi*f/fs);
NTFev=eval(NTF);
Sq=1/(12*fs)*abs(NTFev).^2;
IBN=trapz(f,Sq);
end