%% UMTS: General parameters
clear; clc; clf;

%% INPUT PARAMETERS
L=4; fs=100e6; Bw=4e6; FS=2; % FS=2*Vref=1, where Vref stands for the differential reference voltage
B=3; OSR=fs/(2*Bw); INL_LSB=0;

Vr=FS/2; N=65536;
Ain=0.5;  fin=Bw/3;

%% OPTIMIZATION OF fin FOR MINIMUM SIDELOBES IN FFT
Np=floor(N*fin/fs); % Number of periods of Vin in the simulated time (N/fs)
fin=Np*fs/N; % fin is re-adjusted from an integer Np


%% INTEGRATOR PARAMETERS
vosp=5;
cu=0.5e-12;

cs1=cu; ci1 =4*cs1;              %% INTEG 1: gain 0.25
cs2a=cu; cs2b=cs2a; ci2=2*cs2a;  %% INTEG 2: gain 1, 0.5
cs3a=cu; cs3b=cs3a; ci3=2*cs3a;  %% INTEG 3: gain 1, 0.5, 0.5
cs4a=cu; cs4b=cs3a; ci4=cs4a;    %% INTEG 4: gain 2, 1, 1
%% INHERITED PARAMETERS
ts=1/fs;
vhigh=Vr; vlow=-Vr;

%% SIMSIDES
sim('umts211_PQ.mdl');

[pxx,f,pxx_bin,fbin]=spect(y2,fs);
semilogx(f,10*log10(pxx_bin),'m'); hold on; grid on;

[pxx,f,pxx_bin,fbin]=spect(y3,fs);
semilogx(f,10*log10(pxx_bin),'r');

[pxx,f,pxx_bin,fbin]=spect(y4,fs);
semilogx(f,10*log10(pxx_bin),'b');
xlabel('Frequency (Hz)'); ylabel('PSD x bin (dB)');
axis([1e3 1e8 -220 0]);

text(2.5e3,-190,'SL2');
text(2.5e4,-190,'21');
text(7.5e5,-190,'211');

indsig=max(find(f<=fin));
nsig=15;
Psig=sum(pxx_bin(indsig-nsig:indsig+nsig));
%semilogx(f(indsig-nsig:indsig+nsig),10*log10(pxx_bin(indsig-nsig:indsig+nsig)),'r');
indBw=max(find(f<=Bw));
PBw=sum(pxx_bin(1:indBw));
IBN_dB=10*log10(PBw-Psig)