%% UMTS: General parameters
clear; clc; clf;

%% INPUT PARAMETERS
L=4; fs=100e6; Bw=4e6; FS=2; % FS=2*Vref=1, where Vref stands for the differential reference voltage
B=3; OSR=fs/(2*Bw); INL_FS=0.07;

Delta3=FS/(2^3-1);
INL_LSB=INL_FS/100*FS/Delta3;

Vr=FS/2; N=65536;
Ain=0.5;  fin=Bw/3;

%% INTEGRATOR PARAMETERS
Adc1=10^(65/20); gm1=5e-3; Io1=5e-3;

Adc2=Adc1;  gm2=gm1; Io2=Io1;
Adc3=Adc1;  gm3=gm1; Io3=Io1;
Adc4=Adc1;  gm4=gm1; Io4=Io1;

Avnl1=0; Avnl2=0.1; cnl1=0; cnl2=0; %% ADDED/MODIFIES PARAMETERS COMPARED TO PREVIOUS EXERCISE

cp1=0.1e-15; cp2=0.1e-15;
cu=0.4e-12; cl=0.5e-15;

vosp=5; Ron=1;

cs1=cu;  ci1 =4*cs1;             %% INTEG 1: gain 0.25
cs2a=cu; cs2b=cs2a; ci2=2*cs2a;  %% INTEG 2: gain 1, 0.5
cs3a=cu; cs3b=cs3a; ci3=2*cs3a;  %% INTEG 3: gain 1, 0.5, 0.5
cs4a=cu; cs4b=cs3a; ci4=cs4a;    %% INTEG 4: gain 2, 1, 1

%% INHERITED PARAMETERS
ts=1/fs;
vhigh=Vr; vlow=-Vr;

%% OPTIMIZATION OF fin FOR MINIMUM SIDELOBES IN FFT
Np=floor(N*fin/fs); % Number of periods of Vin in the simulated time (N/fs)
fin=Np*fs/N; % fin is re-adjusted from an integer Np

%% SIMSIDES
sim('umts211_PQ.mdl');
[pxx,f,pxx_bin,fbin]=spect(y4,fs);  hold on; grid on;
semilogx(f,10*log10(pxx_bin),'r');

indsig=max(find(f<=fin));
nsig=15;
%Psig=sum(pxx_bin(indsig-nsig:indsig+nsig));
%semilogx(f(indsig-nsig:indsig+nsig),10*log10(pxx_bin(indsig-nsig:indsig+nsig)),'r');
pxx_bin(indsig-nsig:indsig+nsig)=pxx_bin(indsig-nsig);
indBw=max(find(f<=Bw));
fBw=f(1:indBw);
P_Bw=cumsum(pxx_bin(1:indBw));
semilogx(fBw,10*log10(P_Bw),'r');
IBN_dB=10*log10(P_Bw(end))

sim('umts211_real.mdl');
[pxx,f,pxx_bin,fbin]=spect(y4,fs);  hold on; grid on;
semilogx(f,10*log10(pxx_bin),'b');

xlabel('Frequency (Hz)'); ylabel('PSD x bin (dB)');
axis([1e3 1e8 -200 0]);
shg;

text(2e3,-155,'Quantization noise + All leakages');
text(2e6,-170,'Quantization noise');

indsig=max(find(f<=fin));
nsig=15;
%Psig=sum(pxx_bin(indsig-nsig:indsig+nsig));
%semilogx(f(indsig-nsig:indsig+nsig),10*log10(pxx_bin(indsig-nsig:indsig+nsig)),'r');
pxx_bin(indsig-nsig:indsig+nsig)=pxx_bin(indsig-nsig);
indBw=max(find(f<=Bw));
fBw=f(1:indBw);
P_Bw=cumsum(pxx_bin(1:indBw));
semilogx(fBw,10*log10(P_Bw),'b');
IBN_dB=10*log10(P_Bw(end))