                switch (model)
                    {
                    case 1:     /*Finite and Linear Ron*/
                        {
                            VC1=(VC1OLD+(*uPtrs1[0]-VC1OLD)*(1-exp(-1*TS/(2*RON*C1))));
                            break;
                        }
                    case 2:     /*Non-linear Ron (analytic model)*/
                        {
                            g= p[0];
                            B= p[1];
                            for(i=0;i<k/2;i++) /* Division of the sampling period in "k" dt time intervals */
                            {
                                if (signal==1){ /* Sinewave input */
                                    Vi=A*sin(2*pi*fi*(i*dt+n*TS/2)+phase);}
                                else{
                                    Vi=sig[k/2*n+i]; /*Genric waveform input (g=gON, B=Beta) */
                                }
                                VC1p=(C1+dt*g-sqrt(pow((C1+g*dt),2)+B*dt*(dt*Vi*(B*Vi/4-g)-2*C1*VC1OLDp)))/(B*dt);
                                VC1n=(C1+dt*g-sqrt(pow((C1+g*dt),2)+B*dt*(dt*Vi*(B*Vi/4+g)-2*C1*VC1OLDn)))/(B*dt);
                                VC1OLDp=VC1p;
                                VC1OLDn=VC1n;
                            }
                            VC1=VC1p-VC1n;
                            break;
                        }
                    case 3:     /*Non-linear Ron (lookup table model)*/
                        {
                        for(i=0;i<k/2;i++)
                            {
                            if (signal==1){
                                Vi=A*sin(2*pi*fi*(i*dt+n*TS/2)+phase);}
                            else{
                                Vi=sig[k/2*n+i];
                            }
                            Ronp=0;
                            Ronn=0;
                            for(j=0;j<m;j++)
                            {
                                Ronp = Ronp + (p[j])*pow(Vi/2,m-j-1);
                                Ronn = Ronn + (p[j])*pow(-Vi/2,m-j-1);
                            }
                            VC1p= (VC1OLDp+(Vi/2-VC1OLDp)*(1-exp(-1*dt/(Ronp*C1))));
                            VC1n= (VC1OLDn+(-Vi/2-VC1OLDn)*(1-exp(-1*dt/(Ronn*C1))));
                            VC1OLDp=VC1p;
                            VC1OLDn=VC1n;                                            
                            }
                        VC1= VC1p-VC1n;   
                        break;
                        }