static void mdlOutputs (SimStruct *S, int_T tid)
{
	real_T	*y	= ssGetOutputPortRealSignal (S, 0);
	real_T	*x	= ssGetContStates (S);
	real_T ub = *mxGetPr(ub(S));
    real_T lb = *mxGetPr(lb(S));

    if(x[1]<=lb)
        {x[1]=lb;}
    if(x[1]>=ub)
        {x[1]=ub;}
	
	y[0] = x[1] ;
}

#define MDL_DERIVATIVES

static void mdlDerivatives(SimStruct *S)
{
    real_T *dx	= ssGetdX(S);
	real_T *x = ssGetContStates (S);
	real_T ub = *mxGetPr(ub(S));
    real_T lb = *mxGetPr(lb(S));
	real_T iub = *mxGetPr(iub(S));
    real_T ilb = *mxGetPr(ilb(S));	
	real_T gm1 = *mxGetPr(gm1(S));
    real_T gm2 = *mxGetPr(gm2(S));	    
    real_T fp = *mxGetPr(fp(S));	/* fp= 1/(ra Ca) */        
	real_T C = *mxGetPr(C(S));
    real_T gm = *mxGetPr(gm(S));	    
	real_T et = *mxGetPr(et(S));
    real_T Av = *mxGetPr(Av(S));	    
	real_T  selector = *mxGetPr(selector_param(S));
    InputRealPtrsType uPtrs0 = ssGetInputPortRealSignalPtrs(S,0);
    InputRealPtrsType uPtrs1 = ssGetInputPortRealSignalPtrs(S,1);
    InputRealPtrsType uPtrs2 = ssGetInputPortRealSignalPtrs(S,2);
    real_T vin = *uPtrs0[0];
    real_T iin = *uPtrs1[0];
    real_T noise = *uPtrs2[0];
    real_T input;
    real_T go;
    C=C*(1+et);
    go=gm/Av;    

	if (selector ==1)
		{input=vin;}
	else
		{input=vin+noise;}
		
    /*Non linear transconductance*/
    input=input+gm1*pow(entrada,2)+gm2*pow(entrada,3);

    /*Output Saturation*/
    if(x[1]<=lb)
        {x[1]=lb;}
    if(x[1]>=ub)
        {x[1]=ub;}
    
    /*Input Saturation*/
    if(input<=ilb)
        {input=ilb;}
    if(input>=iub)
        {input=iub;}
    
    dx[0]=fp*(input-gm*x[0]);
    dx[1]=-go/C*x[1]+gm/C*x[0]+1/C*iin;
}
