%% GENERATION OF NOISE SEQUENCE OF GIVEN Vrms AMPLITUDE IN A GIVEN BANDWIDTH
%
% noise_Vrms:   Intended amplitude (in Vrms) of the noise integrated 
%               in the BW_noise bandwidth
% BW_noise:     Bandwidth in which the noise has been integrated to extract 
%               its amplitude
% N:            Numer of samples of the noise time sequence
% fs:           Sampling frequency of the noise time sequence
%
%% SETTING NOISE-SOURCE PARAMETERS
%
noise_Vrms=1e-5;
BW_noise=1e9;
N=65536;
fs=2*BW_noise;
%
%% GENERATION OF NOISE SEQUENCE
%
noise_psd=noise_Vrms^2;
x=sqrt(12*fs/(2*BW_noise)*noise_psd);
y=-x/2+x*rand(N,1);
tstep=1/BW_noise;
%
%% GENERATION OF TIME VECTOR AND SAVING DATA TO THE FILE NAMED noisedata.dat
%
t=0:tstep:(N-1)*tstep;
noisedata=[t' y];
save noisedata.dat noisedata -ascii
%