clear all;

%% Loading and Storing Data from txt (SIMULATION-OUTPUT) files
eval(['load ' 'out1_TB_4thOrder_SR_v01' '.txt']);
eval(['load ' 'out2_TB_4thOrder_SR_v01' '.txt']);
%
Y_1st=eval('out1_TB_4thOrder_SR_v01');
Y_2nd=eval('out2_TB_4thOrder_SR_v01');
%
%% Defining General Simulation Parameters
%
N=2^14; % Number of clock cycles
fs=320e6; % Sampling frequency
ts=1/fs; % Sampling time
t=(1:N)*ts; % Time vector 
fin=1e6; % Input signal frequency
nf=length(Y_1st-1); % Length of output streams
ni=nf-N+1; % Removing initial transient data

% Scaling bitstreams from +1.2,0,-1.2 to +1,0,-1
Y1=Y_1st(ni:nf,1)/-1.2;
Y2=Y_1st(ni:nf,3)/1.2;

X1=Y_2nd(ni:nf,1)/-1.2;
X2=Y_2nd(ni:nf,3)/1.2;

% Transforming 1-of-3 coded digital outputs into 
a single bitstream

out_1st=Y1+Y2;
out_2nd=X1+X2;

% Generating time-based data series

out1=[t' out_1st];
out2=[t' out_2nd];

% Simulating DCL block diagram

sim('CancellationLogic_casc22_SR.mdl');